Code/Areas/ApplicationManagement/Controllers/ComplianceStandardRegulationRCMController.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Logging;
using CyberaniumModels;
using Cyberanium.Factory;
using Microsoft.AspNetCore.Http;
using ClosedXML.Excel;
using System.IO;

namespace Cyberanium.Areas.ApplicationManagement.Controllers
{
    [Area("ApplicationManagement")]

    public class ComplianceStandardRegulationRCMController : Controller
    {
        private readonly ILogger<ComplianceStandardRegulationRCMController> _logger;
        public ComplianceStandardRegulationRCMController(ILogger<ComplianceStandardRegulationRCMController> logger)
        {
            _logger = logger;
        }
        //public async Task<IActionResult> Index(int ID = 0)
        //{
        //    RiskAssessmentRCM obj = new RiskAssessmentRCM();
        //    if (ID>0)
        //    {
        //        obj.ID = ID;
        //    }
        //    obj.AssessMentList = await ApiClientFactory.Instance.GetAssignRiskAssessmentList(2);
        //    obj.DdlSector = new SelectList(await ApiClientFactory.Instance.GetEnumByType(1), "Value", "Name");
        //    obj.DdlCountry = new SelectList(await ApiClientFactory.Instance.GetAllCountry(), "Id", "CountryName");
        //    obj.DdlInternationalStandard = new SelectList(await ApiClientFactory.Instance.GetInternationalStandard(), "ParentISOId", "Title");
        //    ViewBag.message = TempData["success"];
        //    ViewBag.message = TempData["error"];
        //    return View(obj);
        //}
        public async Task<IActionResult> Index2()
        {
            var model = new IRA();
            model.OrganizationList = await ApiClientFactory.Instance.GetAssessmentOrganizationList(3);
            return View(model);
        }
        public IActionResult TabMenu(long orgId = 0, string orgName = "")
        {
            var model = new IRA();
            model.OrgId = orgId;
            model.OrgName = orgName;
            return View(model);
        }
        public async Task<IActionResult> AssignTask(long orgId = 0, string orgName = "")
        {
            var model = new IRA();
            model.OrgId = orgId;
            var res = await ApiClientFactory.Instance.GetStandardAndRegulationRCM(orgId);
            if (res.Count > 0)
            {
                model.ID = res[0].ID;
                model.StandardIDs = res[0].StandardIDs;
                model.RegulationIDs = res[0].RegulationIDs;
                model.StartDate = res[0].StartDate;
                model.EndDate = res[0].EndDate;
                model.AssessorID = res[0].AssessorID;
                model.CompletedDate = res[0].CompletedDate;
            }
            model.RCMListByOrgID = await ApiClientFactory.Instance.GetRCMListByOrgID(orgId);
            model.ddlAssessor = new SelectList(await ApiClientFactory.Instance.getClientadminFillData(orgId), "ClientId", "ClientName");
            model.DdlInternationalStandard = new SelectList(await ApiClientFactory.Instance.GetAllInternationalStandard(), "Id", "Title");
            model.DdllawRegulation = new SelectList(await ApiClientFactory.Instance.GetAllRegulation(), "Id", "Title");
            model.OrgName = orgName;
            return View(model);
        }
        public async Task<IActionResult> PerformAssessment(long orgId = 0, string orgName = "")
        {
            var model = new IRA();
            string str = string.Empty;
            string thead = string.Empty;
            string tbody = string.Empty;
            var res = await ApiClientFactory.Instance.GetStandardAndRegulationRCM(orgId);
            model.SubDomainList = await ApiClientFactory.Instance.GetSubDomainStdRegRCMBID(res[0].RCMId, res[0].StandardIDs);
            var res2 = await ApiClientFactory.Instance.GetRCMControlListByStdRegOrg(res[0].RCMId, res[0].StandardIDs);
            var res3 = await ApiClientFactory.Instance.GetEnumByType(12);
            thead = "<thead class='txtCenter'><tr><th>Control Name</th><th>Control Description</th><th width='15%'>Test of design</th><th width='15%'>Test of effectiveness</th><th width='15%'>OverAll Effectiveness</th><th width='15%'>Remarks</th></tr></thead>";
            foreach (var item in model.SubDomainList)
            {
                str = str + "<div class='panel panel-default'><div class='panel-heading' role='tab' id='heading_" + item.SubDomainId + "'><div class='clsadjust'><div><h4 class='panel-title'>" +
                   "<a class='collapsed' role='button' data-toggle='collapse' data-parent='#accordion1' href='#collapse" + item.SubDomainId + "' aria-expanded='false' aria-controls='collapse" + item.SubDomainId + "'>" +
                   "" + item.SubDomainName + "</a></h4></div><div><label style='margin-right:10px'>Domain Compliance Score</label><input type='text' id=DomainComScore" + item.SubDomainId + " disabled='disabled' value='" + item.DomainCompilancescore + "' style='text-align: center;'/></div></div></div> <div id='collapse" + item.SubDomainId + "' class='panel-collapse collapse' role='tabpanel' aria-labelledby='heading" + item.SubDomainId + "'>" +
                   "<div class='panel-body'><div class='row'><div class='col-12'><div class='table_control'><table class='table' id=tbl_" + item.SubDomainId + ">" + thead + "<tbody>";
                foreach (var item2 in res2)
                {
                    if (item.SubDomainId == item2.SubDomainId)
                    {
                        string html = "<option value='0'>--Select--</option>";
                        string html2 = "<option value='0'>--Select--</option>";
                        foreach (var T in res3)
                        {
                            if (item2.Testofdesign == 1 && T.Value == 1)
                            {
                                html = html + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else if (item2.Testofdesign == 2 && T.Value == 2)
                            {
                                html = html + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else if (item2.Testofdesign == 3 && T.Value == 3)
                            {
                                html = html + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else
                            {
                                html = html + "<option value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            if (item2.Testofeffectiveness == 1 && T.Value == 1)
                            {
                                html2 = html2 + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else if (item2.Testofeffectiveness == 2 && T.Value == 2)
                            {
                                html2 = html2 + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else if (item2.Testofeffectiveness == 3 && T.Value == 3)
                            {
                                html2 = html2 + "<option selected value=" + T.Value + ">" + T.Name + "</option>";
                            }
                            else
                            {
                                html2 = html2 + "<option value=" + T.Value + ">" + T.Name + "</option>";
                            }
                        }
                        str = str + "<tr class='txtCenter'><td id='ControlName" + item2.ControlName + "'><input type='hidden' value=" + item2.ICDId + " />" + item2.ControlName + "</td><td id='ControlDescription" + item2.ControlDescription + "'><input type='hidden' value=" + item2.SubDomainId + " />" + item2.ControlDescription + "</td>" +
                            "<td id='TestOfDesign" + item2.SubDomainId + "'><select class='form-control m_no ClsTestDesign' onchange='fn_bindOverallEffectiveness(this);Calc(this," + item.SubDomainId + ");'>" + html + "</select></td><td id='TestOfEff" + item2.SubDomainId + "'><select class='form-control m_no ClsTestDesign' disabled='disabled' onchange='fn_bindOverallEffectiveness2(this);Calc(this," + item.SubDomainId + ");'>" + html2 + "</select></td><td id='OverAllEff" + item2.SubDomainId + "' ><input type='text' value='" + item2.overalleffectiveness + "' class='form-control' disabled='disabled'/></td><td id='Remarks" + item2.SubDomainId + "'><input type='text' value='" + item2.remarks + "' class='form-control'/></td></tr>";
                    }
                }
                str = str + "</tbody></table></div></div></div></div></div></div>";
            }
            model.HtmlCode = str;
            model.OrgId = orgId;
            model.OrgName = orgName;
            return View(model);
        }
        [HttpPost]
        public async Task<JsonResult> SaveStandardAndRegulationRCM(IRA model)
        {
            _logger.LogInformation("SaveStandardAndRegulationRCM");
            model.CreatedIP = HttpContext.Session.GetString("IP");
            model.CreatedBy = (int)HttpContext.Session.GetInt32("UserId");
            var res = await ApiClientFactory.Instance.SaveStandardAndRegulationRCM(model);
            return Json(res);
        }
        [HttpPost]
        public async Task<JsonResult> SubmitStandardAndRegulationAssessmentRCM(IRA model)
        {
            _logger.LogInformation("SubmitStandardAndRegulationAssessmentRCM");
            model.CreatedIP = HttpContext.Session.GetString("IP");
            model.CreatedBy = (int)HttpContext.Session.GetInt32("UserId");
            var res = await ApiClientFactory.Instance.SubmitStandardAndRegulationAssessmentRCM(model);
            return Json(res);
        }

Code/Areas/ApplicationManagement/Views/ComplianceStandardRegulationRCM/AssignTask.cshtml
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.IRA
@{
    ViewData["Title"] = "Index";
}
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(() => {
        if ($("#ID").val() <= 0) {
            $('#StartDate').val('');
            $('#EndDate').val('');
            $('#CompletedDate').val('');
        }
        $('#Standard').val([@Model.StandardIDs]).change();
        $('.multiple').multiselect('rebuild');
        $('#Regulation').val([@Model.RegulationIDs]).change();
        $('.multiple').multiselect('rebuild');
    })
    function fn_saveStdAndReg() {
        if ($('#Standard').val() == "" || $('#Standard').val() == null) {
            toastr.error('Please select Standard!');
            return false;
        }
        if ($('#Regulation').val() == "" || $('#Regulation').val() == null) {
            toastr.error('Please select Regulation!');
            return false;
        }
        if ($('#StartDate').val() == '') {
            toastr.error('Please enter Assessment start date!');
            return false;
        }
        if ($('#EndDate').val() == '') {
            toastr.error('Please enter Assessment end date!');
            return false;
        }
        if ($('#AssessorID').val() == '') {
            toastr.error('Please select assign to!');
            return false;
        }
        if ($('#CompletedDate').val() == '') {
            toastr.error('Please enter Assessment complete date!');
            return false;
        }
        var model = {
            ID: $('#ID').val(),
            OrgId: $("#OrgId").val(),
            StandardIDs: $("#Standard").val().toString().replace("multiselect-all,", ""),
            RegulationIDs: $("#Regulation").val().toString().replace("multiselect-all,", ""),
            StartDate: $('#StartDate').val(),
            EndDate: $("#EndDate").val(),
            AssessorID: $('#AssessorID option:selected').val(),
            CompletedDate: $("#CompletedDate").val(),
            RCMId: $("#chklatestRCM").val(),

        }
        $.post('/ApplicationManagement/ComplianceStandardRegulationRCM/SaveStandardAndRegulationRCM', { model: model }, function (res) {
            $.get('/ApplicationManagement/ComplianceStandardRegulationRCM/TabMenu', { orgId: $("#OrgId").val(), orgName: $("#OrgName").val() }, (res) => $('#ajaxresult').html(res))
            res.isSuccess ? toastr.success('Saved successfully.') : toastr.error('Something went wrong!');
        })
    }
</script>
<section>
    @Html.HiddenFor(m => m.ID)
    @Html.HiddenFor(m => m.OrgId)
    @Html.HiddenFor(m => m.OrgName)
    <div class="right_section">
        <div class="pb-2 mt-3 mb-3 border-bottom box_title pl-4">
            Assign task for @Model.OrgName
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="TabMenu" asp-controller="ComplianceStandardRegulationRCM" asp-area="ApplicationManagement" asp-route-orgId="@Model.OrgId" asp-route-orgName="@Model.OrgName">Back to Menu</a>

        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div>
                        <div class="pb-2 mb-5 border-bottom box_subtitle">
                            Assignment Scope
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Standard")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        @Html.DropDownListFor(x => x.Standard, Model.DdlInternationalStandard, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })
                                    </div>
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Regulation")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        @Html.DropDownListFor(x => x.Regulation, Model.DdllawRegulation, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple" })

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div style="margin-top:37px">
                        <div class="pb-2 mb-5 border-bottom box_subtitle">
                            Assessment Duration
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Assessment Start Date")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        <input type="date" class="form-control" value="@Model.StartDate.ToString("yyyy-MM-dd")" id="StartDate" min="@DateTime.Now.ToString("yyyy-MM-dd")" onchange="$('#EndDate,#CompletedDate').val(''); $('#EndDate,#CompletedDate').attr('min', $(this).val());" />
                                    </div>
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Assessment End Date")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        <input type="date" class="form-control" value="@Model.EndDate.ToString("yyyy-MM-dd")" id="EndDate" min="@Model.StartDate.ToString("yyyy-MM-dd")" onchange="$('#CompletedDate').val(''); $('#CompletedDate').attr('max', $(this).val());" />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div style="margin-top:37px">
                        <div class="pb-2 mb-5 border-bottom box_subtitle">
                            Task Assignment
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Assign to")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        @Html.DropDownListFor(m => m.AssessorID, Model.ddlAssessor, "--Select--", new { @class = "form-control m_no", required = "required" })
                                    </div>
                                    <div class="col-md-2 col-sm-6 col-xs-12">
                                        @Html.Label("Assessment to be completed by")
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-xs-12">
                                        <input type="date" class="form-control" value="@Model.CompletedDate.ToString("yyyy-MM-dd")" id="CompletedDate" min="@Model.StartDate.ToString("yyyy-MM-dd")" max="@Model.EndDate.ToString("yyyy-MM-dd")" />
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div style="margin-top:37px">
                        <div class="pb-2 mb-5 border-bottom box_subtitle">
                            RCM
                        </div>
                    </div>
                    @{
                        int i = 1;
                    }
                    @foreach (var item in Model.RCMListByOrgID)
                    {
                        if (i == 1)
                        {
                            <div>
                                <div class="pb-2 mb-5 border-bottom box_subtitle">
                                    Latest RCM
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="RCMVersions">
                                        <input id="chklatestRCM" value="@item.ID" class="customcheckbtn" checked type="checkbox" />
                                        <label>@item.Name</label>
                                    </div>
                                </div>
                            </div>
                        }
                        else if (i == 2)
                        {
                            <div>
                                <div class="pb-2 mb-5 border-bottom box_subtitle">
                                    Previous RCM
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="RCMVersions">
                                        <input id="chk_" class="customcheckbtn" type="checkbox" />
                                        <label>@item.Name</label>
                                    </div>
                                </div>
                            </div>
                        }
                        else
                        {
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="RCMVersions">
                                        <input id="chk_" class="customcheckbtn" type="checkbox" />
                                        <label>@item.Name</label>
                                    </div>
                                </div>
                            </div>
                        }
                        i += 1;
                    }
                    <div style="margin-top:37px">
                        <input type="submit" class="btn btn-primary pull-right" onclick="return fn_saveStdAndReg()" value="Confirm and Save" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

Code/Areas/ApplicationManagement/Views/ComplianceStandardRegulationRCM/Index2.cshtml
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.IRA
@{
    ViewData["Title"] = "Index";
}
<script src="~/Script/Master/Layout.js"></script>
<section>
    <div class="right_section">
        <div class="titile_heading">
            <h1>Standards and Regulations RCM</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="assign_panel assign_section">
                        <div class="assign_box active_block fade in">
                            <div class="col-12  table_control">
                                <table id="example2" class="table table-bordered table-hover" style="text-align:left">
                                    <thead>
                                        <tr>
                                            <th style="width:70px">SN</th>
                                            <th>Organizations</th>
                                            <th style="width:130px">Action</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @{int sn = 0;}
                                        @foreach (var item in Model.OrganizationList)
                                        {
                                            <tr>
                                                <td>@(++sn)</td>
                                                <td>@item.Name</td>
                                                <td>
                                                    <a href="#" class="clsStart" onclick="$.get('/ApplicationManagement/ComplianceStandardRegulationRCM/TabMenu', {orgId:@item.Id,orgName:'@item.Name'},function (res) { $('#ajaxresult').html(res) })" title="Start"><i class="fa fa-play"></i></a>
                                                    <a href="/ApplicationManagement/ComplianceStandardRegulationRCM/DownloadPerformAssessmentReportToExcel?orgId=@(item.Id)" class='clsDownload' title="Download Report"><i class="fa fa-download"></i></a>
                                                </td>
                                            </tr>
                                        }
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

Code/Areas/ApplicationManagement/Views/ComplianceStandardRegulationRCM/TabMenu.cshtml
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@model CyberaniumModels.IRA

<section>
    <div class="right_section">
        @Html.HiddenFor(x => x.OrgId)
        <div class="pb-2 mt-3 mb-2 border-bottom box_title pl-4">
            Compliance Against RCM for @Model.OrgName
            <a data-ajax="true" class="backtolist" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index2" asp-controller=" ComplianceStandardRegulationRCM" asp-area="ApplicationManagement">Back to Menu</a>
        </div>
        <div class="col-lg-12 col-md-8 col-sm-8 col-xs-8">
            <div class="right_panel">
                <div class="right_content">
                    <div class="centerbox">
                        <div class="cardbtn">
                            <a href="#" onclick="$.get('/ApplicationManagement/ComplianceStandardRegulationRCM/AssignTask',{orgId:@Model.OrgId,orgName:'@Model.OrgName'},function(res){$('#ajaxresult').html(res)})">
                            <div class="cardbtnIn">
                                <div class="cardbtnimg">
                                    <img src="~/Image/CreateOrganogram/assignTask.png" />
                                </div>
                                <div class="cardbtntext">Assign Task</div>
                            </div>
                            </a>
                        </div>
                        <div class="cardbtn">
                            <a href="#" onclick="$.get('/ApplicationManagement/ComplianceStandardRegulationRCM/PerformAssessment',{orgId:@Model.OrgId,orgName:'@Model.OrgName'},function(res){$('#ajaxresult').html(res)})">
                            <div class="cardbtnIn">
                                <div class="cardbtnimg">
                                    <img src="~/Image/CreateOrganogram/Performassesment.png" />
                                </div>
                                <div class="cardbtntext">Perform Assessment</div>
                            </div>
                            </a>
                        </div>


                    </div>
                </div>
            </div>
        </div>
    </div>
</section>